﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Crud.Model;
using System.Web.Services;

namespace Crud
{
    /// <summary>
    /// Summary description for WebService1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    [System.Web.Script.Services.ScriptService]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class WebService1 : System.Web.Services.WebService
    {

        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World";
        }
        [WebMethod]
        public  List<ScheduleEvent> LoadData()
        {
            return new DataClasses1DataContext().ScheduleEvents.ToList();
        }
        [WebMethod]
        public List<ScheduleEvent> Add(ScheduleEvent value)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();

            int intMax = new DataClasses1DataContext().ScheduleEvents.ToList().ToList().Count > 0 ? new DataClasses1DataContext().ScheduleEvents.ToList().ToList().Max(p => p.Id) : 0;
            DateTime startTime = Convert.ToDateTime(value.StartTime);
            DateTime endTime = Convert.ToDateTime(value.EndTime);
            ScheduleEvent appoint = new ScheduleEvent()
            {
                Id = intMax + 1,
                StartTime = startTime,
                EndTime = endTime,
                Subject = value.Subject,
                IsAllDay = value.IsAllDay,
                RecurrenceId = value.RecurrenceId,
                RecurrenceRule = value.RecurrenceRule,
                RecurrenceException = value.RecurrenceException,
                StartTimezone = value.StartTimezone,
                EndTimezone = value.EndTimezone,
                Location = value.Location,
                Description = value.Description,
            };
            db.ScheduleEvents.InsertOnSubmit(appoint);
            db.SubmitChanges();
            return db.ScheduleEvents.ToList();
        }
        [WebMethod]
        public List<ScheduleEvent> Update(ScheduleEvent value)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            var filterData = db.ScheduleEvents.Where(c => c.Id == Convert.ToInt32(value.Id));
            if (filterData.Count() > 0)
            {
                DateTime startTime = Convert.ToDateTime(value.StartTime);
                DateTime endTime = Convert.ToDateTime(value.EndTime);
                ScheduleEvent appoint = db.ScheduleEvents.Single(A => A.Id == Convert.ToInt32(value.Id));
                appoint.StartTime = startTime;
                appoint.EndTime = endTime;
                appoint.StartTimezone = value.StartTimezone;
                appoint.EndTimezone = value.EndTimezone;
                appoint.Subject = value.Subject;
                appoint.IsAllDay = value.IsAllDay;
                appoint.RecurrenceId = value.RecurrenceId;
                appoint.RecurrenceRule = value.RecurrenceRule;
                appoint.RecurrenceException = value.RecurrenceException;
                appoint.Location = value.Location;
                appoint.Description = value.Description;
            }
            db.SubmitChanges();
            return db.ScheduleEvents.ToList();
        }
        [WebMethod]
        public List<ScheduleEvent> remove(string key)
        {
            DataClasses1DataContext db = new DataClasses1DataContext();
            ScheduleEvent app = db.ScheduleEvents.Where(c => c.Id == Convert.ToInt32(key)).FirstOrDefault();

            if (app != null) db.ScheduleEvents.DeleteOnSubmit(app);
            db.SubmitChanges();
            return db.ScheduleEvents.ToList();
        }
    }
}
